/** @file filter.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef FILTER_CMDLINE_H
#define FILTER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef FILTER_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define FILTER_CMDLINE_PARSER_PACKAGE "para_filter"
#endif

#ifndef FILTER_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define FILTER_CMDLINE_PARSER_VERSION "0.3.0"
#endif

/** @brief Where the command line options are stored */
struct filter_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int loglevel_arg;	/**< @brief set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/**< @brief set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel (0-6) help description.  */
  char ** filter_arg;	/**< @brief Specify filter.
  
  May be given multiple times to 'pipe' the stream
  through arbitrary many filters in an efficient
  way.  The same filter may appear more than once,
  order matters.
  
  Filter options may be specified for each '-f'
  option separately. Note that you will have to
  quote these options like this:
  
  	-f 'compress --inertia 5 --damp 2'
.  */
  char ** filter_orig;	/**< @brief Specify filter.
  
  May be given multiple times to 'pipe' the stream
  through arbitrary many filters in an efficient
  way.  The same filter may appear more than once,
  order matters.
  
  Filter options may be specified for each '-f'
  option separately. Note that you will have to
  quote these options like this:
  
  	-f 'compress --inertia 5 --damp 2'
 original value given at command line.  */
  int filter_min; /**< @brief Specify filter.
  
  May be given multiple times to 'pipe' the stream
  through arbitrary many filters in an efficient
  way.  The same filter may appear more than once,
  order matters.
  
  Filter options may be specified for each '-f'
  option separately. Note that you will have to
  quote these options like this:
  
  	-f 'compress --inertia 5 --damp 2'
's minimum occurreces */
  int filter_max; /**< @brief Specify filter.
  
  May be given multiple times to 'pipe' the stream
  through arbitrary many filters in an efficient
  way.  The same filter may appear more than once,
  order matters.
  
  Filter options may be specified for each '-f'
  option separately. Note that you will have to
  quote these options like this:
  
  	-f 'compress --inertia 5 --damp 2'
's maximum occurreces */
  const char *filter_help; /**< @brief Specify filter.
  
  May be given multiple times to 'pipe' the stream
  through arbitrary many filters in an efficient
  way.  The same filter may appear more than once,
  order matters.
  
  Filter options may be specified for each '-f'
  option separately. Note that you will have to
  quote these options like this:
  
  	-f 'compress --inertia 5 --damp 2'
 help description.  */
  int list_filters_flag;	/**< @brief print list of available filters and exit (default=off).  */
  const char *list_filters_help; /**< @brief print list of available filters and exit help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int filter_given ;	/**< @brief Whether filter was given.  */
  int list_filters_given ;	/**< @brief Whether list_filters was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct filter_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure filter_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure filter_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *filter_args_info_purpose;
/** @brief the usage string of the program */
extern const char *filter_args_info_usage;
/** @brief all the lines making the help output */
extern const char *filter_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int filter_cmdline_parser (int argc, char * const *argv,
  struct filter_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use filter_cmdline_parser_ext() instead
 */
int filter_cmdline_parser2 (int argc, char * const *argv,
  struct filter_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int filter_cmdline_parser_ext (int argc, char * const *argv,
  struct filter_args_info *args_info,
  struct filter_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int filter_cmdline_parser_file_save(const char *filename,
  struct filter_args_info *args_info);

/**
 * Print the help
 */
void filter_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void filter_cmdline_parser_print_version(void);

/**
 * Allocates dynamically a filter_cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized filter_cmdline_parser_params structure
 */
struct filter_cmdline_parser_params *filter_cmdline_parser_params_init(void);

/**
 * Initializes the passed filter_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void filter_cmdline_parser_init (struct filter_args_info *args_info);
/**
 * Deallocates the string fields of the filter_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void filter_cmdline_parser_free (struct filter_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use filter_cmdline_parser_config_file() instead
 */
int filter_cmdline_parser_configfile (char * const filename,
  struct filter_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int filter_cmdline_parser_config_file (char * const filename,
  struct filter_args_info *args_info,
  struct filter_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int filter_cmdline_parser_required (struct filter_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* FILTER_CMDLINE_H */
